# -*- Makefile -*-
ifeq (,)
  exceptions ?= 1
else
  exceptions ?= 0
endif

ifneq ($(findstring -g, -W -Wall -Wpointer-arith -fvisibility=hidden -fvisibility-inlines-hidden  -g -O2 -O2 -pthread -pipe ),)
  debug ?= 1
else
  debug ?= 0
endif

ifneq ($(filter -O2 -O3, -W -Wall -Wpointer-arith -fvisibility=hidden -fvisibility-inlines-hidden  -g -O2 -O2 -pthread -pipe ),)
  optimize ?= 1
else
  optimize ?= 0
endif

ifneq ($(findstring -pthread, -W -Wall -Wpointer-arith -fvisibility=hidden -fvisibility-inlines-hidden  -g -O2 -O2 -pthread -pipe ),)
  threads ?= 1
else
  threads ?= 0
endif

insure ?= 0

PLATFORM_XT_CPPFLAGS = 
PLATFORM_XT_LIBS = -lXt
PLATFORM_XT_LDFLAGS = 

PLATFORM_FL_CPPFLAGS = -I/usr/include/freetype2 -g -O2 -D_THREAD_SAFE -D_REENTRANT
PLATFORM_FL_LIBS = -Wl,-Bsymbolic-functions -lfltk

PLATFORM_X11_CPPFLAGS = 
PLATFORM_X11_LIBS =  -lSM -lICE -lX11 
PLATFORM_X11_LDFLAGS = 

PLATFORM_FOX_CPPFLAGS = -I/usr/include/fox-1.6
PLATFORM_FOX_LIBS = -lFOX-1.6

PLATFORM_TCL_CPPFLAGS = -I/usr/include/tcl8.4
PLATFORM_TCL_LIBS = -L/usr/lib -ltcl8.4

PLATFORM_TK_CPPFLAGS = -I/usr/include/tcl8.4 
PLATFORM_TK_LIBS = -L/usr/lib -ltk8.4 -lX11

PLATFORM_QT_CPPFLAGS = -DQT_SHARED -I/usr/include/qt4 -I/usr/include/qt4/QtCore -I/usr/include/qt4/QtGui  
PLATFORM_QT_LIBS = -lQtGui -lQtCore  

ifeq (,)
  ssl ?= 1
else
  ssl ?= 0
endif

ifeq ($(insure),1)
  CC  = insure
  CXX = insure
endif

PIC      = -fPIC
AR      ?= ar
ARFLAGS  = rsuv
RANLIB   = ranlib

ifeq ($(insure),0)
  CC  ?= gcc
  CXX ?= g++
  CXX_FOR_VERSION_TEST ?= $(CXX)
else
  CXX_FOR_VERSION_TEST ?= g++
endif

ifneq ($(findstring -pipe, -W -Wall -Wpointer-arith -fvisibility=hidden -fvisibility-inlines-hidden  -g -O2 -O2 -pthread -pipe ),)
  pipes ?= 1
else
  pipes ?= 0
endif

CXX_FULL_VERSION := $(shell $(CXX_FOR_VERSION_TEST) --version)

FLAGS_C_CC += $(filter-out -g -O2 -O3 -pipe, -W -Wall -Wpointer-arith -fvisibility=hidden -fvisibility-inlines-hidden  -g -O2 -O2 -pthread -pipe )

ifeq ($(buildbits),32)
  FLAGS_C_CC += -m32
  LDFLAGS    += -m32
endif
ifeq ($(buildbits),64)
  FLAGS_C_CC += -m64
endif

DCFLAGS  += -g
DCCFLAGS += -g
DLD      = $(CXX)
LD       = $(CXX)
LIBS     += -lrt -ldl 

ifeq ($(optimize),1)
  SOFLAGS += -Wl,-O2
endif

SOFLAGS += $(CPPFLAGS) -shared
SOBUILD = $(COMPILE.cc) $(PIC) -o $(VSHDIR)$*.so $<; \
          $(SOLINK.cc) -o $@ $(LDFLAGS) $(VSHDIR)$*.o
PRELIB  = @true

# Test for template instantiation, add to SOFLAGS if SONAME set,
# add -E to LDFLAGS if using GNU ld
#
include $(ACE_ROOT)/include/makeinclude/platform_g++_common.GNU

OCFLAGS  ?= -O2
OCCFLAGS ?= -O2

CFLAGS  += $(FLAGS_C_CC)
CCFLAGS += $(FLAGS_C_CC) $(TEMPLATES_FLAG)

# Added line below to support "Executable Shared Object" files (as
# needed by the service configurator).
# Marius Kjeldahl <mariusk@sn.no, marius@funcom.com>
ifeq ($(threads),1)
    ESOBUILD = $(COMPILEESO.cc) $(PIC) -shared -o $(VSHDIR)$*.so $<
    ifndef PRELIB
       PRELIB = @true
    endif # ! PRELIB
endif
